#include <QtWaylandClient/private/qwayland-output-extension.h>

QT_BEGIN_NAMESPACE

namespace QtWayland {
    qt_output_extension::qt_output_extension(struct ::wl_registry *registry, int id)
    {
        init(registry, id);
    }

    qt_output_extension::qt_output_extension(struct ::qt_output_extension *obj)
        : m_qt_output_extension(obj)
    {
    }

    qt_output_extension::qt_output_extension()
        : m_qt_output_extension(0)
    {
    }

    qt_output_extension::~qt_output_extension()
    {
    }

    void qt_output_extension::init(struct ::wl_registry *registry, int id)
    {
        m_qt_output_extension = static_cast<struct ::qt_output_extension *>(wl_registry_bind(registry, id, &qt_output_extension_interface, 1));
    }

    void qt_output_extension::init(struct ::qt_output_extension *obj)
    {
        m_qt_output_extension = obj;
    }

    bool qt_output_extension::isInitialized() const
    {
        return m_qt_output_extension != 0;
    }

    struct ::qt_extended_output *qt_output_extension::get_extended_output(struct ::wl_output *output)
    {
        return qt_output_extension_get_extended_output(
            m_qt_output_extension,
            output);
    }

    qt_extended_output::qt_extended_output(struct ::wl_registry *registry, int id)
    {
        init(registry, id);
    }

    qt_extended_output::qt_extended_output(struct ::qt_extended_output *obj)
        : m_qt_extended_output(obj)
    {
        init_listener();
    }

    qt_extended_output::qt_extended_output()
        : m_qt_extended_output(0)
    {
    }

    qt_extended_output::~qt_extended_output()
    {
    }

    void qt_extended_output::init(struct ::wl_registry *registry, int id)
    {
        m_qt_extended_output = static_cast<struct ::qt_extended_output *>(wl_registry_bind(registry, id, &qt_extended_output_interface, 1));
        init_listener();
    }

    void qt_extended_output::init(struct ::qt_extended_output *obj)
    {
        m_qt_extended_output = obj;
        init_listener();
    }

    bool qt_extended_output::isInitialized() const
    {
        return m_qt_extended_output != 0;
    }

    void qt_extended_output::set_orientation_update_mask(int32_t orientation)
    {
        qt_extended_output_set_orientation_update_mask(
            m_qt_extended_output,
            orientation);
    }

    void qt_extended_output::extended_output_set_screen_rotation(int32_t )
    {
    }

    void qt_extended_output::handle_set_screen_rotation(
        void *data,
        struct ::qt_extended_output *object,
        int32_t rotation)
    {
        Q_UNUSED(object);
        static_cast<qt_extended_output *>(data)->extended_output_set_screen_rotation(
            rotation);
    }

    const struct qt_extended_output_listener qt_extended_output::m_qt_extended_output_listener = {
        qt_extended_output::handle_set_screen_rotation
    };

    void qt_extended_output::init_listener()
    {
        qt_extended_output_add_listener(m_qt_extended_output, &m_qt_extended_output_listener, this);
    }
}

QT_END_NAMESPACE
